-module(eensy_dev_tools@cli@flash).
-compile([no_auto_import, nowarn_unused_vars, nowarn_unused_function, nowarn_nomatch]).

-export([do_app/1, app/0]).

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy_dev_tools/src/eensy_dev_tools/cli/flash.gleam", 48).
-spec do_app(binary()) -> eensy_dev_tools@cli:cli(nil).
do_app(Platform) ->
    eensy_dev_tools@cli:log(
        <<<<"Flashing ["/utf8, Platform/binary>>/binary, "]"/utf8>>,
        fun() ->
            eensy_dev_tools@cli:do(
                eensy_dev_tools@cli:get_name(),
                fun(Project_name) ->
                    case gleam@string:lowercase(Platform) of
                        <<"esp32"/utf8>> ->
                            _pipe = eensy_dev_tools@project:flash_esp_32(
                                Project_name
                            ),
                            gleam@result:unwrap(_pipe, nil);

                        _ ->
                            nil
                    end,
                    eensy_dev_tools@cli:return(nil)
                end
            )
        end
    ).

-file("/Users/raynerdls/ray.delossantos/apps/eensy-repos/packages/eensy_dev_tools/src/eensy_dev_tools/cli/flash.gleam", 22).
-spec app() -> glint:command(nil).
app() ->
    glint:command_help(
        <<"
Commands for packing BEAM and static files from your project and 
flashing to a device
  "/utf8>>,
        fun() ->
            glint:unnamed_args(
                {eq_args, 1},
                fun() ->
                    glint:flag(
                        eensy_dev_tools@cli@flag:platform(),
                        fun(Platform) ->
                            glint:command(
                                fun(_, _, Flags) ->
                                    Script = (eensy_dev_tools@cli@pack:do_app(
                                        false
                                    )),
                                    case eensy_dev_tools@cli:run(Script, Flags) of
                                        {ok, _} ->
                                            nil;

                                        {error, Error} ->
                                            _pipe = eensy_dev_tools@error:explain(
                                                Error
                                            ),
                                            gleam@io:print_error(_pipe)
                                    end,
                                    Script@1 = (eensy_dev_tools@cli:do(
                                        eensy_dev_tools@cli:get_string(
                                            <<"platform"/utf8>>,
                                            <<"esp32"/utf8>>,
                                            [<<"flash"/utf8>>],
                                            Platform
                                        ),
                                        fun(Platform@1) ->
                                            do_app(Platform@1)
                                        end
                                    )),
                                    case eensy_dev_tools@cli:run(
                                        Script@1,
                                        Flags
                                    ) of
                                        {ok, _} ->
                                            nil;

                                        {error, Error@1} ->
                                            _pipe@1 = eensy_dev_tools@error:explain(
                                                Error@1
                                            ),
                                            gleam@io:print_error(_pipe@1)
                                    end
                                end
                            )
                        end
                    )
                end
            )
        end
    ).
